#include <string.h>
#include <stdio.h>
#define MAXLINE 1000

/* strcpy:  t  s; ,    */
void strcpy1(char *s, char *t) {
	int i;
	i = 0;
	while ((s[i] = t[i]) != '\0')
		i++;
}
/* strcpy:  t  s; ,
    - 1*/
void strcpy2(char *s, char *t) {
	int i;
	i = 0;
	while ((*s = *t) != '\0') {
		s++;
		t++;
	}
}
/* strcpy:  t  s; ,
    - 2*/
void strcpy3(char *s, char *t) {
	while (*s++ = *t++)
		;
}
/* strcmp:  <0,  s<t, 0,  s==t  >0,  s>t */
int strcmp1(char *s, char *t) {
	int i;
	for (i = 0; s[i] == t[i]; i++)
		if (s[i] == '\0')
			return 0;
	return s[i] - t[i];
}
/* strcmp:  <0,  s<t, 0,  s==t  >0,  s>t */
int strcmp2(char *s, char *t) {
	for (; *s == *t; s++, t++)
		if (*s == '\0')
			return 0;
	return *s - *t;
}
/*      echo;  1 */
int main1(int argc, char *argv[]) {
	int i;
	for (i = 1; i < argc; i++)
		printf("%s%s", argv[i], (i < argc - 1) ? " " : "");
	printf("\n");
	return 0;
}

/*      echo;  2 */
int main2(int argc, char *argv[]) {
	while (--argc > 0)
		printf("%s%s", *++argv, (argc > 1) ? " " : "");
	printf("\n");
	return 0;
}

/* getline:    s,    */
int getline(char s[], int lim) {
	int c, i;
	i = 0;
	while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
		s[i++] = c;
	if (c == '\n')
		s[i++] = c;
	s[i] = '\0';
	return i;
}

/* find:  ,    
      */
int mainFind1(int argc, char *argv[]) {
	char line[MAXLINE];
	int found = 0;
	if (argc != 2)
		printf("Usage: find pattern\n");
	else
		while (getline(line, MAXLINE) > 0)
			if (strstr(line, argv[1]) != NULL) {
				printf("%s", line);
				found++;
			}
	return found;
}

/* find:  ,    
      */
int mainFind2(int argc, char *argv[]) {
	char line[MAXLINE];
	long lineno = 0;
	int c, except = 0, number = 0, found = 0;
	while (--argc > 0 && (*++argv)[0] == '-')
		while (c = *++argv[0])
			switch (c) {
			case 'x':
				except = 1;
				break;
			case 'n':
				number = 1;
				break;
			default:
				printf("find: illegal option %c\n", c);
				argc = 0;
				found = -1;
				break;
			}
	if (argc != 1)
		printf("Usage: find -x -n pattern\n");
	else
		while (getline(line, MAXLINE) > 0) {
			lineno++;
			if ((strstr(line, *argv) != NULL) != except) {
				if (number)
					printf("%ld:", lineno);
				printf("%s", line);
				found++;
			}
		}
	return found;
}

int main(int argc, char *argv[]) {

	char string1[50], string2[50], string3[50], string4[50];

	gets(string1);
	strcpy1(string2, string1);
	strcpy2(string3, string1);
	strcpy3(string4, string1);

	printf("string1 = %s\n", string1);
	printf("string2 = %s\n", string2);
	printf("string3 = %s\n", string3);
	printf("string4 = %s\n", string4);

	printf("string2 == string3: %d\n", strcmp1(string2, string3));
	printf("string1 == string4: %d\n", strcmp2(string1, string4));

	printf("Number of arguments: %d\n", argc);
	main1(argc, argv);
	main2(argc, argv);

	mainFind1(argc, argv);
	mainFind2(argc, argv);

	return 0;
}
